Bug 220739 - Image Editor shows sidebar after applying effect in fullscreen mode
Summary: Image Editor shows sidebar after applying effect in fullscreen mode
Status: RESOLVED FIXED
Alias: None
Product: digikam
Classification: Unclassified
Component: Usability-FullScreen (show other bugs)
Version: 1.1.0
Platform: unspecified Linux
: NOR normal with 20 votes (vote)
Target Milestone: ---
Assignee: Digikam Developers
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2009-12-30 23:09 UTC by Simon
Modified: 2017-08-04 13:10 UTC (History)
5 users (show)

See Also:
Latest Commit:
Version Fixed In: 3.2.0


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Simon 2009-12-30 23:09:11 UTC
Version:           1.1.0 (rev.: 1066990) (using 4.3.4 (KDE 4.3.4), Debian packages)
Compiler:          cc
OS:                Linux (i686) release 2.6.32-2.slh.3-sidux-686

Reproduce:
* Open picture in Image Editor
* Hide sidebar, if visible
* Switch to full screen
* Apply any effect (like Curves Adjust), press Apply
Now the sidebar shows up, even though it has been hidden previously.
Comment 1 Marcel Wiesweg 2010-01-21 19:44:20 UTC
Currently in EditorToolIface::loadTool, we just call appendTab and setActiveTab.
For the full screen case, we would have to store state, maybe add a relevant method appendSideBarTab to EditorWindow? Not sure how to best do that without causing side effects.
Comment 2 caulier.gilles 2010-10-22 13:28:48 UTC
*** Bug 207921 has been marked as a duplicate of this bug. ***
Comment 3 Stuart 2011-01-10 11:49:10 UTC
The fullscreen image editor feature would make Digikam my image editor of choice however with this bug, if you make an edit or cancel one, you're really out of fullscreen mode because you now have a sidebar. Please, please get this sorted as the fullscreen mode allows quick editing through the customisable toolbar, looks great and allows you to maximise your screen to look at the photo. I love it apart from this bug!
Comment 4 Stuart 2011-11-16 17:19:28 UTC
Still getting exactly the same thing on windows xp v2.3 32bit installer...
Comment 5 Pravesh Gupta 2013-04-28 10:29:22 UTC
Not able to view this bug, however encountered another bug of this type.

OS : Linux Mint KDE v14
digiKam Version : digiKam 3.2.0-beta2

Steps to Reproduce:-
1)Open ImageEditor.
2)Make Thumbbar visible by checking true to View->Show ThumbBar (CTRL+T).
3)Enter Full Screen Mode (CTRL+SHIFT+F)
4)Exit Full Screen Mode

Result : ThumbBar hides.

Expected Result : ThumbBar should not hide on exiting full screen mode as it was checked to show previously when screen was not in full screen mode.

Pravesh
Comment 6 Pravesh Gupta 2013-04-28 11:18:12 UTC
In Addition to my previous comment (comment #5) :-

Through the steps defined, the right sideBar(Properties etc.) also hides for permanent for permanent in Normal Screen Mode.
However, it is shown in Full Screen Mode of Image Editor but never in Normal Screen Mode. Even if we close the Image Editor and start Image Editor with the other images from the parent digikam window, this happens.

The only way to show right side bar image Editor(in normal mode, not in Full Screen Mode) is to restart digikam.

*This whole behaviour is also noticed in ShowFoto.

Pravesh
Comment 7 caulier.gilles 2013-04-28 12:23:26 UTC
Pravesh,

I must admit that fullscreen mode is a little bit bugous. This is true in all digiKam main windows (albumgui, LT, BQM, Import, etc...)

This must be review in-deep and code which manage full screen mode in all KXmlGuiWindow classes based (listed below) must be factored in common wrapper to reduce code duplication. This wrapper must take a care about full screen mode settings from Setup dialog.

digikam/main/digikamapp.cpp:void DigikamApp::slotToggleFullScreen(bool b)
utilities/importui/main/importui.cpp:void ImportUI::slotToggleFullScreen(bool b)
utilities/queuemanager/main/queuemgrwindow.cpp:void QueueMgrWindow::slotToggleFullScreen(bool b)
utilities/lighttable/lighttablewindow.cpp:void LightTableWindow::slotToggleFullScreen(bool b)
utilities/imageeditor/editor/editorwindow.cpp:void EditorWindow::slotToggleFullScreen(bool b)

Also, in same way that fullscreen mode code must be factored, settings in Setup GUI must be factored too. No need to duplicated configuration for each main digiKam windows, when there exist (sometime there is no dedicated settings by main windows in current implementation)

There are few others dysfunctions about full screen mode, similar to this one. We must take a consideration off all in this project.

Taking all this constraint, we can build safe implementation to manage fullscreen mode.

This can be a good exercise for student...

Gilles Caulier
Comment 8 Pravesh Gupta 2013-04-28 15:21:08 UTC
Hi Gilles,

Should I include this in my project ?

Pravesh
Comment 9 caulier.gilles 2013-04-28 15:31:42 UTC
In theory, no. This is not model/view port subject. It's improvements...

This can be a little project outside GoSC 2013, excepted if you think that you will have time to do it... But i doubt...

Gilles Caulier
Comment 10 Pravesh Gupta 2013-04-28 17:49:33 UTC
Hi Guilles,

K, I am not including this, nor factorizing the classes but I will look if I can fix this bug in Image Editor Window alone.
Comment 11 caulier.gilles 2013-04-28 20:44:17 UTC
ok, this will be a first step

Gilles Caulier
Comment 12 caulier.gilles 2013-04-29 15:48:46 UTC
Pravesh,

I started to write the wrapper, and i patch Image Editor. This fix some dysfunctions. but it's not yet completed.

I need to write GUI settings widget, and patch other KXMLGuiWindow classes...

i will commit the patch for Image Editor ASAP. In charge for you to test step by step when implementation will progress...

Gilles Caulier
Comment 13 caulier.gilles 2013-04-30 04:13:39 UTC
Git commit 73502cc716f1940375d7d805e299d8f93fa58adc by Gilles Caulier.
Committed on 30/04/2013 at 06:02.
Pushed by cgilles into branch 'master'.

Add new FullScreenMngr class dedicated manage full-screen action to digiKam KXMLGuiWindow instances.
This class factorize a lots of code when window is turned on/off to full-screen mode.
This fix problem about visibility restoring with status-bar, menu-bar, and thumb-bar.
First managed digiKam main window is Image Editor.
TODO :
- manage full-screen mode of main windows AlbumGUI, BQM, ImportUI, and LT, through FullScreenMngr.
- manage visibility of side-bars.
- provide a common settings widget to control visibility management in Configuration dialog.
- patch Configuration dialog to provide a fine control of visibility management in full-screen mode for each digiKam main window.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +1    -0    CMakeLists.txt
A  +231  -0    libs/widgets/common/fullscreenmngr.cpp     [License: GPL (v2+)]
A  +89   -0    libs/widgets/common/fullscreenmngr.h     [License: GPL (v2+)]
M  +19   -109  utilities/imageeditor/editor/editorwindow.cpp
M  +0    -5    utilities/imageeditor/editor/editorwindow.h
M  +5    -13   utilities/imageeditor/editor/editorwindow_p.h
M  +12   -8    utilities/setup/setupeditor.cpp

http://commits.kde.org/digikam/73502cc716f1940375d7d805e299d8f93fa58adc
Comment 14 Pravesh Gupta 2013-04-30 14:25:56 UTC
Hi Gilles,

Tested the patches.
Works Fine with ImageEditor, ShowFoto, and LightTable.

Something that I noticed is(although not a big problem or a bug), is that when I switch to Full Screen Mode, show and hide the Left Image ThumbBar, there is noticeable flickering effect of right Properties ThumbBar(for micro seconds).

Apart  from that all good.
I think this bug is fixed.

Pravesh
Comment 15 caulier.gilles 2013-04-30 15:24:07 UTC
Only Image Editor and Showfoto are fixed. LT, BQM, AlbumGUI, ImportUI do not use yet FullScreenMngr. I currently work on it.

Do you take a look on my implementation of this class ?

Gilles Caulier
Comment 16 Pravesh Gupta 2013-04-30 16:03:19 UTC
Not until now, I only tested it.

Pravesh
Comment 17 caulier.gilles 2013-05-01 12:20:36 UTC
Git commit cde52bd90737bd8fe2b7dfdb94eba09578549239 by Gilles Caulier.
Committed on 01/05/2013 at 14:19.
Pushed by cgilles into branch 'master'.

Port fullscreen mode from Light Table to FullScreenMngr.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +23   -87   utilities/lighttable/lighttablewindow.cpp
M  +1    -3    utilities/lighttable/lighttablewindow.h
M  +3    -8    utilities/lighttable/lighttablewindow_p.h
M  +13   -10   utilities/setup/setuplighttable.cpp
M  +1    -1    utilities/setup/setuplighttable.h

http://commits.kde.org/digikam/cde52bd90737bd8fe2b7dfdb94eba09578549239
Comment 18 caulier.gilles 2013-05-01 13:11:37 UTC
Git commit 4b034a235c07758d97b1fe763791abe1bc3c81db by Gilles Caulier.
Committed on 01/05/2013 at 15:10.
Pushed by cgilles into branch 'master'.

Port fullscreen mode from Batch Queue Manager to FullScreenMngr.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +3    -0    libs/widgets/common/fullscreenmngr.h
M  +23   -79   utilities/queuemanager/main/queuemgrwindow.cpp
M  +1    -1    utilities/queuemanager/main/queuemgrwindow.h
M  +4    -8    utilities/queuemanager/main/queuemgrwindow_p.h

http://commits.kde.org/digikam/4b034a235c07758d97b1fe763791abe1bc3c81db
Comment 19 caulier.gilles 2013-05-02 14:13:25 UTC
Git commit b8a7f5ceddc5c112906e94eaedeb42cbb0917638 by Gilles Caulier.
Committed on 02/05/2013 at 16:10.
Pushed by cgilles into branch 'master'.

As under OSX, if toolbar is hidden during fullscreen mode, we display fullscreen switch button on top-right corner of active sceen when mouse is moved on this corner by end user.
Mouse move envent is handle by an event filter plug over managed window. FullScreenMngr is now a QObject class based.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +63   -1    libs/widgets/common/fullscreenmngr.cpp
M  +9    -1    libs/widgets/common/fullscreenmngr.h
M  +0    -1    utilities/imageeditor/editor/editorwindow.cpp
M  +0    -1    utilities/lighttable/lighttablewindow.cpp
M  +0    -1    utilities/queuemanager/main/queuemgrwindow.cpp

http://commits.kde.org/digikam/b8a7f5ceddc5c112906e94eaedeb42cbb0917638
Comment 20 Veaceslav Munteanu 2013-05-02 16:08:11 UTC
Git commit 115ff76386c0835ed4f647b30eb6f80eac387d5f by Veaceslav Munteanu, on behalf of Gilles Caulier.
Committed on 02/05/2013 at 16:10.
Pushed by munteanu into branch 'picassafacetag'.

As under OSX, if toolbar is hidden during fullscreen mode, we display fullscreen switch button on top-right corner of active sceen when mouse is moved on this corner by end user.
Mouse move envent is handle by an event filter plug over managed window. FullScreenMngr is now a QObject class based.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +63   -1    libs/widgets/common/fullscreenmngr.cpp
M  +9    -1    libs/widgets/common/fullscreenmngr.h
M  +0    -1    utilities/imageeditor/editor/editorwindow.cpp
M  +0    -1    utilities/lighttable/lighttablewindow.cpp
M  +0    -1    utilities/queuemanager/main/queuemgrwindow.cpp

http://commits.kde.org/digikam/115ff76386c0835ed4f647b30eb6f80eac387d5f
Comment 21 caulier.gilles 2013-05-03 09:38:17 UTC
Git commit 8dcfa0b102f4b4d53a5095b8daae0efc1582a4da by Gilles Caulier.
Committed on 03/05/2013 at 11:33.
Pushed by cgilles into branch 'master'.

For a better factoring and better management of all common features from digiKam KXmlGuiWindow based main windows
a new class named DXmlGuiWindow have been created. All digiKam main windows will be based on. Currently IE, BQM, and LT are done.
AlbumGUI and ImportUI still TODO.
This class replace FullScreenMngr as well. FullScreen mode are no managed through DXmlGuiWindow. Later more factoring will be done in this class, as
all Help digiKam dialogs (DB stats, Components info, etc...)
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +2    -1    CMakeLists.txt
M  +7    -3    digikam/utils/albumsettings.cpp
M  +3    -0    digikam/utils/albumsettings.h
D  +0    -404  libs/widgets/common/fullscreenmngr.cpp
D  +0    -140  libs/widgets/common/fullscreenmngr.h
A  +104  -0    libs/widgets/common/fullscreensettings.cpp     [License: GPL (v2+)]
A  +61   -0    libs/widgets/common/fullscreensettings.h     [License: GPL (v2+)]
M  +19   -43   utilities/imageeditor/editor/editorwindow.cpp
M  +3    -8    utilities/imageeditor/editor/editorwindow.h
M  +0    -3    utilities/imageeditor/editor/editorwindow_p.h
M  +8    -27   utilities/lighttable/lighttablewindow.cpp
M  +3    -4    utilities/lighttable/lighttablewindow.h
M  +0    -3    utilities/lighttable/lighttablewindow_p.h
M  +6    -24   utilities/queuemanager/main/queuemgrwindow.cpp
M  +2    -4    utilities/queuemanager/main/queuemgrwindow.h
M  +0    -4    utilities/queuemanager/main/queuemgrwindow_p.h
M  +2    -1    utilities/setup/setupeditor.cpp
M  +2    -1    utilities/setup/setuplighttable.cpp

http://commits.kde.org/digikam/8dcfa0b102f4b4d53a5095b8daae0efc1582a4da
Comment 22 caulier.gilles 2013-05-03 20:51:47 UTC
Git commit d6ddab1db393a973f90fbe628ae49b0b91bfe3b7 by Gilles Caulier.
Committed on 03/05/2013 at 22:38.
Pushed by cgilles into branch 'master'.

Check toolbars visibility before FullScreen mode and restore it after.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +88   -40   libs/widgets/common/dxmlguiwindow.cpp

http://commits.kde.org/digikam/d6ddab1db393a973f90fbe628ae49b0b91bfe3b7
Comment 23 caulier.gilles 2013-05-03 20:54:36 UTC
Git commit 5511e68fcb1054c292beff81f0f2e5e4635f550d by Gilles Caulier.
Committed on 03/05/2013 at 22:54.
Pushed by cgilles into branch 'master'.

Check thumbbar visibility before FullScreen mode and restore it after.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +20   -10   libs/widgets/common/dxmlguiwindow.cpp
M  +4    -0    libs/widgets/common/dxmlguiwindow.h
M  +5    -0    utilities/imageeditor/editor/editorwindow.cpp
M  +1    -0    utilities/imageeditor/editor/editorwindow.h

http://commits.kde.org/digikam/5511e68fcb1054c292beff81f0f2e5e4635f550d
Comment 24 caulier.gilles 2013-05-03 21:04:32 UTC
Git commit 99601b3df7c7837069b90e1744c89b2070a7a832 by Gilles Caulier.
Committed on 03/05/2013 at 23:03.
Pushed by cgilles into branch 'master'.

Check menubar and statusbar visibilities before FullScreen mode and restore it after.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +34   -4    libs/widgets/common/dxmlguiwindow.cpp

http://commits.kde.org/digikam/99601b3df7c7837069b90e1744c89b2070a7a832
Comment 25 caulier.gilles 2013-05-04 17:16:56 UTC
Git commit a1bb7a21fc367966beba3d6a1af81c9b201b6544 by Gilles Caulier.
Committed on 04/05/2013 at 19:15.
Pushed by cgilles into branch 'master'.

Manage FullScreen mode from AlbumGUI through DXmlGuiWindow
Polish API
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +17   -83   digikam/main/digikamapp.cpp
M  +6    -6    digikam/main/digikamapp.h
M  +7    -0    libs/widgets/common/dxmlguiwindow.cpp
M  +9    -4    libs/widgets/common/dxmlguiwindow.h
M  +7    -21   utilities/imageeditor/editor/editorwindow.cpp
M  +1    -2    utilities/imageeditor/editor/editorwindow.h

http://commits.kde.org/digikam/a1bb7a21fc367966beba3d6a1af81c9b201b6544
Comment 26 caulier.gilles 2013-05-04 18:40:12 UTC
Git commit 392c928cec8b5092cd383b328002a5fa7652fa16 by Gilles Caulier.
Committed on 04/05/2013 at 20:39.
Pushed by cgilles into branch 'master'.

Manage FullScreen mode from ImportUI through DXmlGuiWindow
Polish API
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +7    -0    digikam/main/digikamapp.cpp
M  +2    -5    digikam/main/digikamapp_p.h
M  +19   -101  utilities/importui/main/importui.cpp
M  +6    -7    utilities/importui/main/importui.h
M  +0    -8    utilities/importui/main/importui_p.h

http://commits.kde.org/digikam/392c928cec8b5092cd383b328002a5fa7652fa16
Comment 27 caulier.gilles 2013-05-06 07:29:10 UTC
Git commit 9d2bb7da9fdd805cc7c23d3d9ba3ecc5d247a48d by Gilles Caulier.
Committed on 06/05/2013 at 09:28.
Pushed by cgilles into branch 'master'.

add new Full-screen option to hide side-bars
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +1    -1    digikam/main/digikamapp.cpp
M  +1    -1    digikam/main/digikamapp.h
M  +18   -9    libs/widgets/common/dxmlguiwindow.cpp
M  +8    -6    libs/widgets/common/dxmlguiwindow.h
M  +17   -5    libs/widgets/common/fullscreensettings.cpp
M  +1    -1    utilities/imageeditor/editor/editorwindow.cpp
M  +1    -1    utilities/imageeditor/editor/editorwindow.h
M  +1    -1    utilities/importui/main/importui.cpp
M  +1    -1    utilities/importui/main/importui.h
M  +2    -2    utilities/lighttable/lighttablewindow.cpp
M  +1    -1    utilities/lighttable/lighttablewindow.h
M  +0    -20   utilities/queuemanager/main/queuemgrwindow.cpp
M  +0    -2    utilities/queuemanager/main/queuemgrwindow.h
M  +1    -1    utilities/setup/setuplighttable.cpp

http://commits.kde.org/digikam/9d2bb7da9fdd805cc7c23d3d9ba3ecc5d247a48d
Comment 28 caulier.gilles 2013-05-06 08:00:03 UTC
Git commit 52cdc362797c6eb92d7768d1cad7b67e4833055f by Gilles Caulier.
Committed on 06/05/2013 at 09:59.
Pushed by cgilles into branch 'master'.

Image Editor and Light Table windows now manage side-bars visibility in Full-Screen mode.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +1    -1    libs/widgets/common/dxmlguiwindow.cpp
M  +7    -5    libs/widgets/common/dxmlguiwindow.h
M  +2    -1    libs/widgets/common/fullscreensettings.cpp
M  +1    -1    utilities/imageeditor/editor/editorwindow.cpp
M  +1    -1    utilities/lighttable/lighttablewindow.cpp
M  +1    -1    utilities/setup/setupeditor.cpp
M  +1    -1    utilities/setup/setuplighttable.cpp

http://commits.kde.org/digikam/52cdc362797c6eb92d7768d1cad7b67e4833055f
Comment 29 caulier.gilles 2013-05-06 08:14:29 UTC
Git commit 8cda9359d08eeff8712203be7271aee29c841231 by Gilles Caulier.
Committed on 06/05/2013 at 10:13.
Pushed by cgilles into branch 'master'.

Add fullscreen mode options to AlbumGUI : toolbars, thumbbar, and sidebars are managed.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676

M  +1    -1    digikam/main/digikamapp.cpp
M  +1    -0    libs/widgets/common/dxmlguiwindow.h
M  +40   -24   utilities/setup/setupalbumview.cpp

http://commits.kde.org/digikam/8cda9359d08eeff8712203be7271aee29c841231
Comment 30 caulier.gilles 2013-05-06 08:30:05 UTC
Git commit a8e10da1a0fb247ff6c361de4f5069ec77e4115c by Gilles Caulier.
Committed on 06/05/2013 at 10:28.
Pushed by cgilles into branch 'master'.

Add fullscreen mode options to ImportUI : toolbars, thumbbar, and sidebars are managed.
Related: bug 214107, bug 289262, bug 236234, bug 258180, bug 293676
FIXED-IN: 3.2.0

M  +2    -1    libs/widgets/common/dxmlguiwindow.h
M  +1    -1    utilities/importui/main/importui.cpp
M  +19   -4    utilities/setup/setupcamera.cpp
M  +1    -1    utilities/setup/setupcamera.h

http://commits.kde.org/digikam/a8e10da1a0fb247ff6c361de4f5069ec77e4115c